<div class="dx-fieldset">
<div class="dx-fieldset-header">Standalone button</div>
<div class="dx-field">
<div class="dx-field-label">Text and icon</div>
<div class="dx-field-value">
<dx-drop-down-button
text="Download Trial"
[dropDownOptions]="{ width: 230 }"
icon="save"
[items]="downloads"
(onItemClick)="onItemClick($event)"
></dx-drop-down-button>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Custom template and actions</div>
<div class="dx-field-value">
<dx-drop-down-button
id="custom-template"
[splitButton]="true"
[useSelectMode]="false"
[items]="profileSettings"
displayExpr="name"
keyExpr="id"
(onButtonClick)="onButtonClick($event)"
(onItemClick)="onItemClick($event)"
template="template"
>
<div *dxTemplate="let data of 'template'">
<div class="button-img-container">
<div class="button-img-indicator"></div>
<img
class="button-img"
src="../../../../images/employees/51.png"
alt="employee"
/>
</div>
<div class="text-container">
<div class="button-title">Olivia Peyton</div>
<div class="button-row">IT Manager</div>
</div>
</div>
</dx-drop-down-button>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Embedded in a Toolbar</div>
<div class="dx-field">
<dx-toolbar>
<dxi-toolbar-item
location="before"
widget="dxDropDownButton"
[options]="{
items: alignments,
displayExpr: 'name',
keyExpr: 'value',
selectedItemKey: 'justify',
width: 125,
stylingMode: 'text',
useSelectMode: true,
onSelectionChanged: onAlignmentChanged
}"
>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
widget="dxDropDownButton"
[options]="{
onInitialized: onColorPickerInit,
items: colors,
icon: 'square',
stylingMode: 'text',
dropDownOptions: { width: 'auto' },
dropDownContentTemplate: 'colorpicker'
}"
>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
widget="dxDropDownButton"
[options]="{
stylingMode: 'text',
displayExpr: 'name',
keyExpr: 'value',
useSelectMode: true,
items: fontSizes,
selectedItemKey: 14,
onSelectionChanged: onFontSizeChanged,
itemTemplate: 'fontItem'
}"
>
</dxi-toolbar-item>
<dxi-toolbar-item
location="before"
widget="dxDropDownButton"
[options]="{
stylingMode: 'text',
icon: 'indent',
displayExpr: 'name',
keyExpr: 'value',
useSelectMode: true,
items: lineHeights,
selectedItemKey: 1.35,
onSelectionChanged: onLineHeightChanged
}"
>
</dxi-toolbar-item>
<div
*dxTemplate="let data of 'fontItem'"
[style.fontSize]="data.value + 'px'"
>
{{ data.name }}
</div>
<div *dxTemplate="let data of 'colorpicker'">
<div class="custom-color-picker">
@for (iconColor of colors; track iconColor) {
<i
class="color dx-icon dx-icon-square"
[style.color]="iconColor"
(click)="onColorClick(iconColor)"
></i>
}
</div>
</div>
</dx-toolbar>
</div>
<div class="dx-field">
<p
id="text"
[style.fontSize]="fontSize + 'px'"
[style.lineHeight]="lineHeight"
[style.color]="color"
[style.textAlign]="alignment"
>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod
tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim
veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea
commodo consequat. Duis aute irure dolor in reprehenderit in voluptate
velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat
cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id
est laborum.</p
>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { enableProdMode, Component, provideZoneChangeDetection } from '@angular/core';
import notify from 'devextreme/ui/notify';
import { DxToolbarModule } from 'devextreme-angular';
import { DxDropDownButtonModule, DxDropDownButtonComponent, DxDropDownButtonTypes } from 'devextreme-angular/ui/drop-down-button';
import { ItemObject, Service } from './app.service';
if (!document.location.host.includes('localhost')) {
enableProdMode();
}
type Color = string;
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxDropDownButtonModule,
DxToolbarModule,
],
})
export class AppComponent {
dropDownButton: DxDropDownButtonComponent['instance'];
colors: Color[];
downloads: string[];
profileSettings: ItemObject[];
fontSizes: ItemObject[];
lineHeights: ItemObject[];
alignments: ItemObject[];
fontSize = 14;
color: string = null;
lineHeight = 1.35;
alignment = 'left';
constructor(service: Service) {
this.colors = service.getColors();
this.fontSizes = service.getFontSizes();
this.downloads = service.getDownloads();
this.profileSettings = service.getProfileSettings();
this.alignments = service.getAlignments();
this.lineHeights = service.getLineHeights();
}
onAlignmentChanged = (e: DxDropDownButtonTypes.SelectionChangedEvent): void => {
this.alignment = e.item.value;
};
onFontSizeChanged = (e: DxDropDownButtonTypes.SelectionChangedEvent): void => {
this.fontSize = e.item.value;
};
onLineHeightChanged = (e: DxDropDownButtonTypes.SelectionChangedEvent): void => {
this.lineHeight = e.item.value;
};
onButtonClick(e: DxDropDownButtonTypes.ButtonClickEvent): void {
notify(`Go to ${e.element.querySelector('.button-title').textContent}'s profile`, 'success', 600);
}
onItemClick(e: DxDropDownButtonTypes.ItemClickEvent): void {
notify(e.itemData.name || e.itemData, 'success', 600);
}
onColorPickerInit = (e: DxDropDownButtonTypes.InitializedEvent): void => {
this.dropDownButton = e.component;
};
onColorClick(color: Color): void {
const iconElement = this.dropDownButton.element().getElementsByClassName('dx-icon-square')[0] as HTMLElement;
iconElement.style.color = color;
this.color = color;
this.dropDownButton.close();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .demo-container .dx-fieldset:first-child {
width: 500px;
}
.custom-color-picker {
width: 82px;
padding: 5px;
}
.color {
cursor: pointer;
font-size: 18px;
}
.text-container {
padding-inline: 12px 4px;
display: flex;
align-items: flex-start;
flex-direction: column;
}
.button-img-container {
position: relative;
height: 32px;
}
.button-img {
width: 32px;
height: 32px;
position: relative;
border-width: 1px;
border-style: solid;
border-color: var(--dx-color-border);
border-radius: 50%;
}
.button-img-indicator {
position: absolute;
background-color: var(--dx-color-danger);
top: -1px;
inset-inline-end: -1px;
width: 10px;
height: 10px;
border-radius: 50%;
border-width: 2px;
border-style: solid;
border-color: var(--dx-color-main-bg);
z-index: 1;
}
.button-title {
line-height: 20px;
}
.button-row {
font-size: 12px;
line-height: 14px;
opacity: 0.6;
}
::ng-deep #custom-template .dx-button {
height: 46px;
}
::ng-deep #custom-template .dx-button.dx-dropdownbutton-action .dx-button-content {
padding-inline: 12px;
}
import { Injectable } from '@angular/core';
import { DxDropDownButtonTypes } from 'devextreme-angular/ui/drop-down-button';
export type ItemObject = DxDropDownButtonTypes.Item & { value: number | string; name: string };
const colors = [null, '#980000', '#ff0000', '#ff9900', '#ffff00', '#00ff00', '#00ffff', '#4a86e8', '#0000ff', '#9900ff', '#ff00ff', '#ff3466'];
const profileSettings: ItemObject[] = [
{ value: 1, name: 'Profile', icon: 'user' },
{
value: 4, name: 'Messages', icon: 'email', badge: '5',
},
{ value: 2, name: 'Friends', icon: 'group' },
{ value: 3, name: 'Exit', icon: 'runner' },
];
const downloads = ['Download Trial For Visual Studio', 'Download Trial For All Platforms', 'Package Managers'];
const alignments: ItemObject[] = [
{ value: 'left', name: 'Left', icon: 'alignleft' },
{ value: 'right', name: 'Right', icon: 'alignright' },
{ value: 'center', name: 'Center', icon: 'aligncenter' },
{ value: 'justify', name: 'Justify', icon: 'alignjustify' },
];
const fontSizes: ItemObject[] = [
{ value: 10, name: '10px' },
{ value: 12, name: '12px' },
{ value: 14, name: '14px' },
{ value: 16, name: '16px' },
{ value: 18, name: '18px' },
];
const lineHeights: ItemObject[] = [
{ value: 1, name: '1' },
{ value: 1.35, name: '1.35' },
{ value: 1.5, name: '1.5' },
{ value: 2, name: '2' },
];
@Injectable()
export class Service {
getColors(): string[] {
return colors;
}
getDownloads(): string[] {
return downloads;
}
getAlignments(): ItemObject[] {
return alignments;
}
getProfileSettings(): ItemObject[] {
return profileSettings;
}
getFontSizes(): ItemObject[] {
return fontSizes;
}
getLineHeights(): ItemObject[] {
return lineHeights;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.25/package.json',
'npm:devexpress-gantt@4.1.67/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.7"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Drop Down Button

The DropDownButton is a button that opens a drop-down menu. The button displays a text and an icon.

Menu items can be specified in the items or dataSource properties. Use dataSource if data is remote or should be processed. To customize menu items, implement an itemTemplate.

The DropDownButton stores the most recent selected menu item if you set the useSelectMode property to true. In this case, the button uses the selected item’s text and icon.

You can implement a dropDownContentTemplate to replace the drop-down menu with custom content.

To track and handle events, use the onButtonClick, onItemClick, and onSelectionChanged event handlers.

To get started with the DevExtreme DropDownButton component, refer to the following tutorial for step-by-step instructions: Getting Started with DropDownButton.

Backend API
<template> <div> <div class="dx-fieldset"> <div class="dx-fieldset-header">Single usage</div> <div class="dx-field"> <div class="dx-field-label"> Custom static text </div> <div class="dx-field-value"> <DxDropDownButton :items="data.downloads" :drop-down-options="{ width: 230 }" text="Download Trial" icon="save" @item-click="onItemClick" /> </div> </div> <div class="dx-field"> <div class="dx-field-label"> Custom main button action </div> <div class="dx-field-value"> <DxDropDownButton :split-button="true" :use-select-mode="false" :items="data.profileSettings" text="Sandra Johnson" icon="../../../../images/gym/coach-woman.png" display-expr="name" key-expr="id" @button-click="onButtonClick" @item-click="onItemClick" /> </div> </div> </div> <div class="dx-fieldset"> <div class="dx-fieldset-header">Usage in a toolbar</div> <div class="dx-field"> <DxToolbar :items="toolbarItems"> <template #fontItem="{ data }"> <div :style="{ fontSize: data.size + 'px'}"> {{ data.text }} </div> </template> <template #colorpicker="{ data }"> <div class="custom-color-picker"> <i v-for="(itemColor, i) in data" :key="i" :class="itemColor ? 'color dx-icon dx-icon-square' : 'color dx-icon dx-icon-square dx-theme-text-color'" :style="{ color: itemColor }" @click="onColorClick(itemColor)" /> </div> </template> </DxToolbar> </div> <div class="dx-field"> <p id="text" :style="{ textAlign: alignment, fontSize: fontSize, color: color, lineHeight: lineHeight }" >Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p> </div> </div> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; import DxDropDownButton from 'devextreme-vue/drop-down-button'; import DxToolbar from 'devextreme-vue/toolbar'; import notify from 'devextreme/ui/notify'; import service from './data.ts'; import 'whatwg-fetch'; const alignment = ref('left'); const color = ref(null); const fontSize = ref('14px'); const lineHeight = ref(1.35); let colorPicker; const data = service.getData(); const toolbarItems = [ { location: 'before', widget: 'dxDropDownButton', options: { displayExpr: 'name', keyExpr: 'id', selectedItemKey: 3, width: 125, stylingMode: 'text', useSelectMode: true, onSelectionChanged: (e) => { alignment.value = e.item.name.toLowerCase(); }, items: data.alignments, }, }, { location: 'before', widget: 'dxDropDownButton', options: { items: data.colors, onInitialized: ({ component }) => { colorPicker = component; }, icon: 'square', stylingMode: 'text', dropDownOptions: { width: 'auto' }, dropDownContentTemplate: 'colorpicker', }, }, { location: 'before', widget: 'dxDropDownButton', options: { stylingMode: 'text', displayExpr: 'text', keyExpr: 'size', useSelectMode: true, items: data.fontSizes, selectedItemKey: 14, onSelectionChanged: (e) => { fontSize.value = `${e.item.size}px`; }, itemTemplate: 'fontItem', }, }, { location: 'before', widget: 'dxDropDownButton', options: { stylingMode: 'text', icon: 'indent', displayExpr: 'text', keyExpr: 'lineHeight', useSelectMode: true, items: data.lineHeights, selectedItemKey: 1.35, onSelectionChanged: (e) => { lineHeight.value = e.item.lineHeight; }, }, }, ]; function onButtonClick(e) { notify(`Go to ${e.component.option('text')}'s profile`, 'success', 600); } function onItemClick(e) { notify(e.itemData.name || e.itemData, 'success', 600); } function onColorClick(clickedColor) { color.value = clickedColor; colorPicker.element().getElementsByClassName('dx-icon-square')[0].style.color = clickedColor; colorPicker.close(); } </script> <style scoped> .demo-container .dx-fieldset:first-child { width: 500px; } .dx-popup-content > .dx-template-wrapper.custom-color-picker { width: 82px; padding: 5px; } .dx-button-content img.dx-icon { width: 24px; height: 24px; } .color { cursor: pointer; font-size: 18px; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'root:': '../../../../../', 'npm:': 'https://unpkg.com/', }, map: { 'vue': 'npm:vue@3.3.4/dist/vue.esm-browser.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js', 'demo-ts-loader': 'root:utils/demo-ts-loader.js', 'svg-loader': 'root:utils/svg-loader.js', 'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.6/cjs', 'devextreme-vue': 'npm:devextreme-vue@23.2.6/cjs', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.54/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; System.config(window.config);
const colors = [null, '#980000', '#ff0000', '#ff9900', '#ffff00', '#00ff00', '#00ffff', '#4a86e8', '#0000ff', '#9900ff', '#ff00ff', '#ff3466']; const profileSettings = [ { id: 1, name: 'Profile', icon: 'user' }, { id: 4, name: 'Messages', icon: 'email', badge: '5', }, { id: 2, name: 'Friends', icon: 'group' }, { id: 3, name: 'Exit', icon: 'runner' }, ]; const downloads = ['Download Trial For Visual Studio', 'Download Trial For All Platforms', 'Package Managers']; const alignments = [ { id: 1, name: 'Left', icon: 'alignleft' }, { id: 4, name: 'Right', icon: 'alignright' }, { id: 2, name: 'Center', icon: 'aligncenter' }, { id: 3, name: 'Justify', icon: 'alignjustify' }, ]; const fontSizes = [ { size: 10, text: '10px' }, { size: 12, text: '12px' }, { size: 14, text: '14px' }, { size: 16, text: '16px' }, { size: 18, text: '18px' }, ]; const lineHeights = [ { lineHeight: 1, text: '1' }, { lineHeight: 1.35, text: '1.35' }, { lineHeight: 1.5, text: '1.5' }, { lineHeight: 2, text: '2' }, ]; export default { getData() { return { colors, profileSettings, downloads, alignments, fontSizes, lineHeights, }; }, };
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <script src="https://unpkg.com/typescript@4.2.4/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://unpkg.com/@vue/compiler-sfc@3.3.4/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

If you have technical questions, please create a support ticket in the DevExpress Support Center.
import React, { useCallback, useMemo, useState } from 'react';
import DropDownButton, { DropDownButtonTypes } from 'devextreme-react/drop-down-button';
import Toolbar from 'devextreme-react/toolbar';
import { Template } from 'devextreme-react/core/template';
import { ButtonTypes } from 'devextreme-react/button';
import notify from 'devextreme/ui/notify';
import service from './data.ts';
import ColorIcon from './ColorIcon.tsx';
import DropDownButtonTemplate from './DropDownButtonTemplate.tsx';
import 'whatwg-fetch';
type TextAlign = 'center' | 'end' | 'justify' | 'left' | 'match-parent' | 'right' | 'start';
const buttonDropDownOptions = { width: 230 };
const data = service.getData();
const itemTemplateRender: React.FC<{ size: number; text: string }> = (item) => (
<div style={{ fontSize: `${item.size}px` }}>
{item.text}
</div>
);
const App: React.FC = () => {
const [alignment, setAlignment] = useState<TextAlign>('left');
const [color, setColor] = useState(null);
const [fontSize, setFontSize] = useState(14);
const [lineHeight, setLineHeight] = useState(1.35);
const [colorPicker, setColorPicker] = useState(null);
const onButtonClick = useCallback((e: ButtonTypes.ClickEvent) => {
notify(`Go to ${e.element.querySelector('.button-title').textContent}'s profile`, 'success', 600);
}, []);
const onItemClick = useCallback((e: DropDownButtonTypes.ItemClickEvent) => {
notify(e.itemData.name || e.itemData, 'success', 600);
}, []);
const onColorClick = useCallback((selectedColor) => {
setColor(selectedColor);
const squareIcon = colorPicker.element().getElementsByClassName('dx-icon-square')[0];
squareIcon.style.color = selectedColor;
colorPicker.close();
}, [colorPicker]);
const onInitialized = useCallback((e: DropDownButtonTypes.InitializedEvent) => {
setColorPicker(e.component);
}, [setColorPicker]);
const toolbarItems = useMemo(() => [
{
location: 'before',
widget: 'dxDropDownButton',
options: {
displayExpr: 'name',
keyExpr: 'id',
selectedItemKey: 3,
width: 125,
stylingMode: 'text',
useSelectMode: true,
onSelectionChanged: (e): void => {
setAlignment(e.item.name.toLowerCase());
},
items: data.alignments,
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
items: data.colors,
icon: 'square',
stylingMode: 'text',
dropDownOptions: { width: 'auto' },
onInitialized,
dropDownContentTemplate: 'colorpicker',
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
stylingMode: 'text',
displayExpr: 'text',
keyExpr: 'size',
useSelectMode: true,
items: data.fontSizes,
selectedItemKey: 14,
onSelectionChanged: (e: DropDownButtonTypes.SelectionChangedEvent): void => {
setFontSize(e.item.size);
},
itemTemplate: 'fontItem',
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
stylingMode: 'text',
icon: 'indent',
displayExpr: 'text',
keyExpr: 'lineHeight',
useSelectMode: true,
items: data.lineHeights,
selectedItemKey: 1.35,
onSelectionChanged: (e: DropDownButtonTypes.SelectionChangedEvent): void => {
setLineHeight(e.item.lineHeight);
},
},
},
], [setAlignment, setFontSize, setLineHeight, onInitialized]);
return (
<div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Standalone button</div>
<div className="dx-field">
<div className="dx-field-label">
Text and icon
</div>
<div className="dx-field-value">
<DropDownButton
text="Download Trial"
icon="save"
dropDownOptions={buttonDropDownOptions}
items={data.downloads}
onItemClick={onItemClick}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">
Custom template and actions
</div>
<div className="dx-field-value">
<DropDownButton
id="custom-template"
splitButton={true}
useSelectMode={false}
items={data.profileSettings}
displayExpr="name"
keyExpr="id"
onButtonClick={onButtonClick}
onItemClick={onItemClick}
render={DropDownButtonTemplate}
>
</DropDownButton>
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Embedded in a Toolbar</div>
<div className="dx-field">
<Toolbar items={toolbarItems}>
<Template name="colorpicker">
<div className="custom-color-picker">
{data.colors.map((colorValue, i) => (
<ColorIcon key={i} color={colorValue} onClick={onColorClick} />
))}
</div>
</Template>
<Template name="fontItem" render={itemTemplateRender}>
</Template>
</Toolbar>
</div>
<div className="dx-field" style={{
color,
textAlign: alignment,
lineHeight,
fontSize: `${fontSize}px`,
}}>
<p id="text">Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>
</div>
</div>
</div>
);
};
export default App;
xxxxxxxxxx
import React, { useCallback, useMemo, useState } from 'react';
import DropDownButton from 'devextreme-react/drop-down-button';
import Toolbar from 'devextreme-react/toolbar';
import { Template } from 'devextreme-react/core/template';
import notify from 'devextreme/ui/notify';
import service from './data.js';
import ColorIcon from './ColorIcon.js';
import DropDownButtonTemplate from './DropDownButtonTemplate.js';
import 'whatwg-fetch';
const buttonDropDownOptions = { width: 230 };
const data = service.getData();
const itemTemplateRender = (item) => <div style={{ fontSize: `${item.size}px` }}>{item.text}</div>;
const App = () => {
const [alignment, setAlignment] = useState('left');
const [color, setColor] = useState(null);
const [fontSize, setFontSize] = useState(14);
const [lineHeight, setLineHeight] = useState(1.35);
const [colorPicker, setColorPicker] = useState(null);
const onButtonClick = useCallback((e) => {
notify(
`Go to ${e.element.querySelector('.button-title').textContent}'s profile`,
'success',
600,
);
}, []);
const onItemClick = useCallback((e) => {
notify(e.itemData.name || e.itemData, 'success', 600);
}, []);
const onColorClick = useCallback(
(selectedColor) => {
setColor(selectedColor);
const squareIcon = colorPicker.element().getElementsByClassName('dx-icon-square')[0];
squareIcon.style.color = selectedColor;
colorPicker.close();
},
[colorPicker],
);
const onInitialized = useCallback(
(e) => {
setColorPicker(e.component);
},
[setColorPicker],
);
const toolbarItems = useMemo(
() => [
{
location: 'before',
widget: 'dxDropDownButton',
options: {
displayExpr: 'name',
keyExpr: 'id',
selectedItemKey: 3,
width: 125,
stylingMode: 'text',
useSelectMode: true,
onSelectionChanged: (e) => {
setAlignment(e.item.name.toLowerCase());
},
items: data.alignments,
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
items: data.colors,
icon: 'square',
stylingMode: 'text',
dropDownOptions: { width: 'auto' },
onInitialized,
dropDownContentTemplate: 'colorpicker',
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
stylingMode: 'text',
displayExpr: 'text',
keyExpr: 'size',
useSelectMode: true,
items: data.fontSizes,
selectedItemKey: 14,
onSelectionChanged: (e) => {
setFontSize(e.item.size);
},
itemTemplate: 'fontItem',
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
stylingMode: 'text',
icon: 'indent',
displayExpr: 'text',
keyExpr: 'lineHeight',
useSelectMode: true,
items: data.lineHeights,
selectedItemKey: 1.35,
onSelectionChanged: (e) => {
setLineHeight(e.item.lineHeight);
},
},
},
],
[setAlignment, setFontSize, setLineHeight, onInitialized],
);
return (
<div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Standalone button</div>
<div className="dx-field">
<div className="dx-field-label">Text and icon</div>
<div className="dx-field-value">
<DropDownButton
text="Download Trial"
icon="save"
dropDownOptions={buttonDropDownOptions}
items={data.downloads}
onItemClick={onItemClick}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Custom template and actions</div>
<div className="dx-field-value">
<DropDownButton
id="custom-template"
splitButton={true}
useSelectMode={false}
items={data.profileSettings}
displayExpr="name"
keyExpr="id"
onButtonClick={onButtonClick}
onItemClick={onItemClick}
render={DropDownButtonTemplate}
></DropDownButton>
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Embedded in a Toolbar</div>
<div className="dx-field">
<Toolbar items={toolbarItems}>
<Template name="colorpicker">
<div className="custom-color-picker">
{data.colors.map((colorValue, i) => (
<ColorIcon
key={i}
color={colorValue}
onClick={onColorClick}
/>
))}
</div>
</Template>
<Template
name="fontItem"
render={itemTemplateRender}
></Template>
</Toolbar>
</div>
<div
className="dx-field"
style={{
color,
textAlign: alignment,
lineHeight,
fontSize: `${fontSize}px`,
}}
>
<p id="text">
Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor
incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud
exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure
dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.
Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt
mollit anim id est laborum.
</p>
</div>
</div>
</div>
);
};
export default App;
xxxxxxxxxx
import React from 'react';
interface ColorIconProps {
key: number;
color: string;
onClick: Function;
}
class ColorIcon extends React.Component<ColorIconProps> {
constructor(props) {
super(props);
this.onClick = this.onClick.bind(this);
}
onClick(): void {
this.props.onClick(this.props.color);
}
render(): JSX.Element {
return (
<i
onClick={this.onClick}
className="color dx-icon dx-icon-square"
style={{ color: this.props.color }}
/>
);
}
}
export default ColorIcon;
xxxxxxxxxx
import React from 'react';
const Avatar: React.FC<{ icon: string }> = ({ icon }) => (
<div className="button-img-container">
<div className="button-img-indicator"></div>
<img className="button-img" src={icon} alt="employee" />
</div>
);
const ButtonDescription: React.FC<{ text: string; description: string }> = ({ text, description }) => (
<div className="text-container">
<div className="button-title">{text}</div>
<div className="button-row">{description}</div>
</div>
);
const DropDownButtonTemplate: React.FC = () => (
<React.Fragment>
<Avatar icon="images/employees/51.png" />
<ButtonDescription text="Olivia Peyton" description="IT Manager" />
</React.Fragment>
);
export default DropDownButtonTemplate;
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
xxxxxxxxxx
const colors = [null, '#980000', '#ff0000', '#ff9900', '#ffff00', '#00ff00', '#00ffff', '#4a86e8', '#0000ff', '#9900ff', '#ff00ff', '#ff3466'];
const profileSettings = [
{ id: 1, name: 'Profile', icon: 'user' },
{
id: 4, name: 'Messages', icon: 'email', badge: '5',
},
{ id: 2, name: 'Friends', icon: 'group' },
{ id: 3, name: 'Exit', icon: 'runner' },
];
const downloads = ['Download Trial For Visual Studio', 'Download Trial For All Platforms', 'Package Managers'];
const alignments = [
{ id: 1, name: 'Left', icon: 'alignleft' },
{ id: 4, name: 'Right', icon: 'alignright' },
{ id: 2, name: 'Center', icon: 'aligncenter' },
{ id: 3, name: 'Justify', icon: 'alignjustify' },
];
const fontSizes = [
{ size: 10, text: '10px' },
{ size: 12, text: '12px' },
{ size: 14, text: '14px' },
{ size: 16, text: '16px' },
{ size: 18, text: '18px' },
];
const lineHeights = [
{ lineHeight: 1, text: '1' },
{ lineHeight: 1.35, text: '1.35' },
{ lineHeight: 1.5, text: '1.5' },
{ lineHeight: 2, text: '2' },
];
export default {
getData() {
return {
colors, profileSettings, downloads, alignments, fontSizes, lineHeights,
};
},
};
xxxxxxxxxx
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
'bundles:': 'bundles/',
'externals:': 'bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@24.2.5/cjs',
'devextreme-react': 'npm:devextreme-react@24.2.5/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.15/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.59/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
xxxxxxxxxx
import React from 'react';
class ColorIcon extends React.Component {
constructor(props) {
super(props);
this.onClick = this.onClick.bind(this);
}
onClick() {
this.props.onClick(this.props.color);
}
render() {
return (
<i
onClick={this.onClick}
className="color dx-icon dx-icon-square"
style={{ color: this.props.color }}
/>
);
}
}
export default ColorIcon;
xxxxxxxxxx
import React from 'react';
const Avatar = ({ icon }) => (
<div className="button-img-container">
<div className="button-img-indicator"></div>
<img
className="button-img"
src={icon}
alt="employee"
/>
</div>
);
const ButtonDescription = ({ text, description }) => (
<div className="text-container">
<div className="button-title">{text}</div>
<div className="button-row">{description}</div>
</div>
);
const DropDownButtonTemplate = () => (
<React.Fragment>
<Avatar icon="images/employees/51.png" />
<ButtonDescription
text="Olivia Peyton"
description="IT Manager"
/>
</React.Fragment>
);
export default DropDownButtonTemplate;
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
xxxxxxxxxx
const colors = [
null,
'#980000',
'#ff0000',
'#ff9900',
'#ffff00',
'#00ff00',
'#00ffff',
'#4a86e8',
'#0000ff',
'#9900ff',
'#ff00ff',
'#ff3466',
];
const profileSettings = [
{ id: 1, name: 'Profile', icon: 'user' },
{
id: 4,
name: 'Messages',
icon: 'email',
badge: '5',
},
{ id: 2, name: 'Friends', icon: 'group' },
{ id: 3, name: 'Exit', icon: 'runner' },
];
const downloads = [
'Download Trial For Visual Studio',
'Download Trial For All Platforms',
'Package Managers',
];
const alignments = [
{ id: 1, name: 'Left', icon: 'alignleft' },
{ id: 4, name: 'Right', icon: 'alignright' },
{ id: 2, name: 'Center', icon: 'aligncenter' },
{ id: 3, name: 'Justify', icon: 'alignjustify' },
];
const fontSizes = [
{ size: 10, text: '10px' },
{ size: 12, text: '12px' },
{ size: 14, text: '14px' },
{ size: 16, text: '16px' },
{ size: 18, text: '18px' },
];
const lineHeights = [
{ lineHeight: 1, text: '1' },
{ lineHeight: 1.35, text: '1.35' },
{ lineHeight: 1.5, text: '1.5' },
{ lineHeight: 2, text: '2' },
];
export default {
getData() {
return {
colors,
profileSettings,
downloads,
alignments,
fontSizes,
lineHeights,
};
},
};
xxxxxxxxxx
<html lang="en">
<head></head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
xxxxxxxxxx
.demo-container .dx-fieldset:first-child {
width: 500px;
}
.custom-color-picker {
width: 82px;
padding: 5px;
}
.color {
cursor: pointer;
font-size: 18px;
}
.text-container {
padding-inline-start: 12px;
padding-inline-end: 4px;
display: flex;
align-items: flex-start;
flex-direction: column;
}
.button-img-container {
position: relative;
height: 32px;
}
.button-img {
width: 32px;
height: 32px;
position: relative;
border-width: 1px;
border-style: solid;
border-color: var(--dx-color-border);
border-radius: 50%;
}
.button-img-indicator {
position: absolute;
background-color: var(--dx-color-danger);
top: -1px;
inset-inline-end: -1px;
width: 10px;
height: 10px;
border-radius: 50%;
border-width: 2px;
border-style: solid;
border-color: var(--dx-color-main-bg);
z-index: 1;
}
.button-title {
line-height: 20px;
}
.button-row {
font-size: 12px;
line-height: 14px;
opacity: 0.6;
}
#custom-template .dx-button {
height: 46px;
}
#custom-template .dx-button.dx-dropdownbutton-action .dx-button-content {
padding-inline-start: 12px;
padding-inline-end: 12px;
}
Menu items can be specified in the items or dataSource properties. Use dataSource if data is remote or should be processed.
DropDownButton stores the most recent selected menu item if you set the useSelectMode property to true
. In this case, the button uses the selected item's text and icon.
To customize DropDownButton, specify the the following options:
-
itemTemplate
Customizes menu items. -
template
Customizes a base button. -
dropDownContentTemplate
Replaces the drop-down menu with custom content.
To track and handle events, use the onButtonClick, onItemClick, and onSelectionChanged event handlers.